package javax.swing.plaf.basic;

import javax.swing.Action;
import javax.swing.ActionMap;
import javax.swing.text.PasswordView;
import javax.swing.text.View;
import javax.swing.text.Element;
import javax.swing.LookAndFeel;
import javax.swing.UIManager;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;

public class BasicPasswordFieldUI extends BasicTextFieldUI
{
    public BasicPasswordFieldUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new BasicPasswordFieldUI();
    }
    
    @Override
    protected String getPropertyPrefix() {
        return "PasswordField";
    }
    
    @Override
    protected void installDefaults() {
        super.installDefaults();
        Character propertyValue = (Character)UIManager.getDefaults().get(this.getPropertyPrefix() + ".echoChar");
        if (propertyValue != null) {
            LookAndFeel.installProperty(this.getComponent(), "echoChar", propertyValue);
        }
    }
    
    @Override
    public View create(Element elem) {
        return new PasswordView(elem);
    }
    
    @Override
    ActionMap createActionMap() {
        ActionMap actionMap = super.createActionMap();
        if (actionMap.get("select-word") != null) {
            Action value = actionMap.get("select-line");
            if (value != null) {
                actionMap.remove("select-word");
                actionMap.put("select-word", value);
            }
        }
        return actionMap;
    }
}
